package org.sonatype.tycho.p2.publisher;

import java.util.List;

import org.sonatype.aether.artifact.Artifact;
import org.sonatype.tycho.p2.publisher.model.InstallableUnit;
import org.sonatype.tycho.p2.publisher.model.artifact.InstallableArtifact;

public class PublisherResult
{

    private final List<InstallableUnit> installableUnits;

    private final List<InstallableUnit> rootInstallableUnits;

    private final List<Artifact> artifacts;

    private final List<InstallableArtifact> installableArtifacts;

    PublisherResult( final List<InstallableUnit> installableUnits, final List<InstallableUnit> rootInstallableUnits,
                     final List<InstallableArtifact> installableArtifacts, final List<Artifact> artifacts )
    {
        this.installableUnits = installableUnits;
        this.rootInstallableUnits = rootInstallableUnits;
        this.installableArtifacts = installableArtifacts;
        this.artifacts = artifacts;
    }

    public List<Artifact> getArtifacts()
    {
        return artifacts;
    }

    public List<InstallableArtifact> getInstallableArtifacts()
    {
        return installableArtifacts;
    }

    public List<InstallableUnit> getInstallableUnits()
    {
        return installableUnits;
    }

    public List<InstallableUnit> getRootInstallableUnits()
    {
        return rootInstallableUnits;
    }
}
