package org.sonatype.tycho.p2.publisher.impl;

import java.util.Properties;

import org.sonatype.aether.graph.DependencyNode;
import org.sonatype.tycho.p2.eclipse.bridge.EclipseInstance;
import org.sonatype.tycho.p2.publisher.PublishAction;
import org.sonatype.tycho.p2.publisher.Publisher;
import org.sonatype.tycho.p2.publisher.PublisherLifecycleParticipant;
import org.sonatype.tycho.p2.publisher.PublisherResult;
import org.sonatype.tycho.p2.publisher.facade.BundlePublisher;

public class DefaultPublisher
    implements Publisher
{

    private final PublisherLifecycleParticipant participant;

    private final EclipseInstance eclipse;

    public DefaultPublisher( final PublisherLifecycleParticipant participant, final EclipseInstance eclipse )
    {
        this.participant = participant;
        this.eclipse = eclipse;
    }

    public PublisherResult publish( final DependencyNode dependencyTree, final Properties properties )
    {
        final BundlePublisher bundlePublisher = eclipse.getService( BundlePublisher.class );

        final PublisherResult result = new PublishAction( dependencyTree, participant, properties, bundlePublisher ).execute();

        return result;
    }

}
