package org.sonatype.tycho.p2.publisher.impl;

import java.util.Collection;
import java.util.Map;

import org.codehaus.plexus.component.annotations.Component;
import org.codehaus.plexus.component.annotations.Requirement;
import org.sonatype.tycho.p2.eclipse.bridge.EclipseInstance;
import org.sonatype.tycho.p2.publisher.CompositePublisherLifecycleParticipant;
import org.sonatype.tycho.p2.publisher.Publisher;
import org.sonatype.tycho.p2.publisher.PublisherFactory;
import org.sonatype.tycho.p2.publisher.PublisherLifecycleParticipant;

@Component( role = PublisherFactory.class )
public class DefaultPublisherFactory
    implements PublisherFactory
{

    @Requirement( role = PublisherLifecycleParticipant.class )
    private Map<String, PublisherLifecycleParticipant> participantsMap;

    public Publisher create( final EclipseInstance eclipse )
    {
        final Collection<PublisherLifecycleParticipant> participants = participantsMap.values();
        final PublisherLifecycleParticipant compositeParticipant =
            CompositePublisherLifecycleParticipant.composite( participants.toArray( new PublisherLifecycleParticipant[participants.size()] ) );
        return new DefaultPublisher( compositeParticipant, eclipse );
    }

}
